/*!
  \file
  \brief text2prn.dll  C++ Ŏg߂̃bpNX
  \author ːϏI  
*/
#include	"stdafx.h"
#include	"t2pd.h"

namespace
{
	template<typename T>
	static void get_address(T& func, HINSTANCE& entry, const char* name)
	{
		// ev[ǧ^肷邽߂ɁA
		// {Ȃ߂lɂȂ֐̃AhXŎw

		func = reinterpret_cast<T>(GetProcAddress(entry, name));
		if (func == NULL)
			throw text2prnDll::DllException(text2prnDll::DllException::NO_EXPORT_FUNC);
	}
}

namespace text2prnDll
{

	HINSTANCE T2PD::hDll_;
	T2PD::FuncOpen T2PD::open;
	T2PD::FuncOutputText T2PD::output_text;
	T2PD::FuncNewColumn T2PD::new_column;
	T2PD::FuncNewPage T2PD::new_page;
	T2PD::FuncGetPrintInfo T2PD::get_print_info;
	T2PD::FuncSetOutputPage T2PD::set_output_page;
	T2PD::FuncPrint T2PD::print;
	T2PD::FuncShow T2PD::show;
	T2PD::FuncCancel T2PD::cancel;

	T2PD::T2PD(T2PD_Property& prop, HDC dc) : h_(NULL)
	{
		assert(open != NULL);

		h_ = open(&prop, dc);
		if (h_ == NULL) {
			throw PropertyException(prop.error_code);
		}
	}

	T2PD::~T2PD()
	{
		if (h_ != NULL) {
			assert(cancel != NULL);
			cancel(h_);
		}
	}

	void T2PD::loadDll(LPCTSTR path)
	{
		assert(hDll_ == NULL);
		hDll_ = ::LoadLibrary(path);
		if (hDll_ == NULL)
			throw DllException(DllException::NOT_FOUND_DLL);

		get_address(open, hDll_, "Open");
		get_address(output_text, hDll_, "OutputText");
		get_address(new_column, hDll_, "NewColumn");
		get_address(new_page, hDll_, "NewPage");
		get_address(get_print_info, hDll_, "GetPrintInfo");
		get_address(set_output_page, hDll_, "SetOutputPage");
		get_address(print, hDll_, "Print");
		get_address(show, hDll_, "Show");
		get_address(cancel, hDll_, "Cancel");
	}
	
	void T2PD::releaseDll()
	{
		if (hDll_ != NULL) {
			::FreeLibrary(hDll_);
			hDll_ = NULL;
		}
	}
}
