/*!
  \file
  \brief text2prn.dll  C++ Ŏg߂̃wb_t@C
  \author ːϏI  
*/
#ifndef	__TEXT2PRN_DLL_H
#define	__TEXT2PRN_DLL_H

#include	<cassert>
#include	<windows.h>

// ----- T2PD_Property::byte_base ɐݒ肷l
#define T2PD_BASE_CHAR_PAR_LINE		(1)	//!< 1s̕
#define T2PD_BASE_LINE_PAR_COLUMN	(2)	//!< 1i̍s
#define T2PD_BASE_FONT_SIZE			(3)	//!< tHgTCY

// ----- T2PD_Property::option ɐݒ肷l
// ȉ̃IvVgݍ킹Ďw肷
#define	T2PD_OPTION_NO_WRAP			(0x01)	//!< s͐܂ԂA]͎̂Ă
#define	T2PD_OPTION_COLUMN_LINE		(0x02)	//!< ig̊Ԃɋ؂o
#define T2PD_OPTION_PAGE_NUMBER		(0x04)	//!< y[Wo
#define T2PD_OPTION_KINSOKU			(0x08)	//!< ֑
#define T2PD_OPTION_LOGFONT			(0x10)	//!< tHgLOGFONTŎw

// ----- G[R[h
#define T2PD_ERROR_NONE					(0)		//!< G[Ȃ
#define T2PD_ERROR_BASE_TYPE			(-1)	//!< base_type s
#define T2PD_ERROR_BASE_VALUE			(-2)	//!< base_value s
#define T2PD_ERROR_COLUMN				(-3)	//!< column s
#define T2PD_ERROR_TAB_WIDTH			(-4)	//!< tab_width s
#define T2PD_ERROR_LINE_NUMBER			(-5)	//!< output_line_number s
#define T2PD_ERROR_INIT_LINE_NUMBER		(-6)	//!< initial_line_number s
#define T2PD_ERROR_LINE_NUMBER_DIGIT	(-7)	//!< line_number_digit s
#define T2PD_ERROR_FONT_NAME			(-8)	//!< tHgȂ
#define T2PD_ERROR_SPACE_TOP			(-9)	//!< space_top s
#define T2PD_ERROR_SPACE_BOTTOM			(-10)	//!< space_bottom s
#define T2PD_ERROR_SPACE_LEFT			(-11)	//!< space_left s
#define T2PD_ERROR_SPACE_RIGHT			(-12)	//!< space_right s
#define T2PD_ERROR_LINE_SPACE			(-13)	//!< line_space s
#define T2PD_ERROR_COLUMN_SPACE			(-14)	//!< column_space s
#define T2PD_ERROR_TITLE				(-15)	//!< title w

#define T2PD_ERROR_PAGE_SPACE_LARGE		(-50)	//!< y[W̗]傫߂
#define T2PD_ERROR_COLUMN_MANY			(-51)	//!< ig
#define T2PD_ERROR_CHAR_MANY			(-52)	//!< 
#define T2PD_ERROR_PRINT_NOTHING		(-53)	//!< 1s\ł
#define T2PD_ERROR_LINE_MANY			(-54)	//!< s
#define T2PD_ERROR_FONT_LARGE			(-55)	//!< tHg傫߂
#define T2PD_ERROR_LINE_NO_DIGIT_LARGE	(-56)	//!< sԍ̌傫߂

#define T2PD_ERROR_FONT_CREATE			(-100)	//!< tHg쐬s
#define T2PD_ERROR_PRINTER				(-101)	//!< v^(DC)̐ݒُ
#define T2PD_ERROR_PRINTER_DC			(-102)	//!< v^DCُ
#define T2PD_ERROR_DEFAULT_PRINTER		(-103)	//!< v^G[

namespace text2prnDll
{

#pragma	pack(1)

	/*!
	  \brief ݒ
	*/
	struct T2PD_Property
	{
		int error_code;				//!< G[R[h
		int base_type;				//!< tHgTCY̎w@
		int base_value;				//!< tHgTCY
		int column;					//!< ig
		int tab_width;				//!< ^u
		int option;					//!< o̓IvV
		int output_line_number;		//!< sԍ̕\Ԋu
		int initial_line_number;	//!< ŏ̍s̍sԍ
		int line_number_digit;		//!< sԍ̌
		LPCWSTR font_name;			//!< tHg
		int space_top;				//!< y[W]()
		int space_bottom;			//!< y[W]()
		int space_left;				//!< y[W]()
		int space_right;			//!< y[W](E)
		int line_space;				//!< s
		int column_space;			//!< iǧ
		LPCWSTR no_first_chars;		//!< s֎~
		LPCWSTR no_last_chars;		//!< s֎~
		LPCWSTR title;				//!< ^Cg
		LPCWSTR header;				//!< wb_
		LPCWSTR footer;				//!< tb^
	};

	/*!
	  \brief eɂĂ̏
	*/
	struct T2PD_PrintInfo
	{
		double font_size;			//!< tHgTCY
		int char_count_par_line;	//!< 1sɈ镶
		int line_count_par_column;	//!< 1igɈs
		int pages;					//!< y[W
	};

#pragma	pack()

	/*!
	  \brief O
	*/	
	class Exception
	{
	  private:
		int code_;
	  protected:
		Exception(int code) : code_(code) {}
	  public:
		//! G[R[h擾
		int GetCode() const {return code_;}
	};

	/*!
	  \brief ݒlɊւO
	*/
	class PropertyException : public Exception
	{
	  public:
		PropertyException(int code) : Exception(code) {}
	};

	/*!
	  \brief DLLɊւO
	*/
	class DllException : public Exception
	{
	  public:
		//! G[R[h
		enum {
			NOT_FOUND_DLL,	//!< DLLȂ
			NO_EXPORT_FUNC,	//!< KvȊ֐
		};
	  public:
		DllException(int code) : Exception(code) {}
	};

	/*!
	  \brief text2prn.dll ̃bpNX

	  \par gpF

	  <pre>
	  T2PD::loadDll(\"text2prn.dll\");

	  T2PD_Property prop;
	  [ prop̐ݒ ]

	  T2PD t2pd(prop);
	  t2pd.OutputText(\"`\");
	  t2pd.Print();

	  T2PD::releaseDll();
	  </pre>
	*/
	class T2PD
	{
	  private:
		typedef HANDLE (PASCAL *FuncOpen)(T2PD_Property*, HDC);
		typedef void (PASCAL *FuncOutputText)(HANDLE, LPCWSTR);
		typedef void (PASCAL *FuncNewColumn)(HANDLE);
		typedef void (PASCAL *FuncNewPage)(HANDLE);
		typedef void (PASCAL *FuncGetPrintInfo)(HANDLE, T2PD_PrintInfo*);
		typedef int (PASCAL *FuncSetOutputPage)(HANDLE, LPCWSTR);
		typedef int (PASCAL *FuncPrint)(HANDLE);
		typedef HWND (PASCAL *FuncShow)(HANDLE, HWND, HWND);
		typedef void (PASCAL *FuncCancel)(HANDLE);
	 
	  private:
		static HINSTANCE hDll_;
		static FuncOpen open;
		static FuncOutputText output_text;
		static FuncNewColumn new_column;
		static FuncNewPage new_page;
		static FuncGetPrintInfo get_print_info;
		static FuncSetOutputPage set_output_page;
		static FuncPrint print;
		static FuncShow show;
		static FuncCancel cancel;

		HANDLE h_;			//!< text2prn.dll p̃nh

	public:
		/*!
		  \brief ivr[ĵ߂̃CX^X쐬B

		  dc  NULL w肵ꍇ́AK̃v^gp܂B
		  
		  \param [in] prop ݒ
		  \param [in] dc ΏۂƂȂv^̃foCXReLXg
		  \exception PropertyException ݒɊԈႢ
		*/
		T2PD(T2PD_Property& prop, HDC dc = NULL);

		~T2PD();

		/*!
		  \brief 镶w肷B

		  KvɉāAĂяo܂B		  

		  \param [in] text 镶
		*/
		void OutputText(LPCWSTR text)
		{
			assert(h_ != NULL && output_text != NULL && text != NULL);
			output_text(h_, text);
		}

		/*!
		  \brief iB
		*/
		void NewColumn()
		{
			assert(h_ != NULL && new_column != NULL);
			new_column(h_);
		}

		/*!
		  \brief y[WB
		*/
		void NewPage()
		{
			assert(h_ != NULL && new_page != NULL);
			new_page(h_);
		}

        /*!
		  \brief eɊւ擾B 
		  \return eɂĂ̏
		*/
		T2PD_PrintInfo GetPrintInfo()
		{
			T2PD_PrintInfo info;
			assert(h_ != NULL && get_print_info != NULL);
			get_print_info(h_, &info);
			return info;
		}

		/*!
		  \brief y[Wԍw肷B

		  pages NULLw肷ƑSy[WB

		  ĂяóAŌ̌Ăяoê݂LƂȂB

		  vr[́A̐ݒ͖B

		  \param [in] pages y[Wԍ
		  \retval true I
		  \retval false y[Wԍ̎wɖ肠
		*/
		bool SetOutputPage(LPCWSTR pages = NULL)
		{
			assert(h_ != NULL && set_output_page != NULL);
			return set_output_page(h_, pages) != 0;
		}

		/*!
		  \brief B

		  ̃\bhďóÃCX^X̑S\bhɂȂB

		  \retval 1ȏ I
		  \retval 0ȉ s
		*/
		int Print()
		{
			assert(h_ != NULL && print != NULL);
			const int result = print(h_);
			h_ = NULL;
			return result;
		}

		/*!
		  \brief vr[ʂ\B

		  ̃\bhďóÃCX^X̑S\bhɂȂB

		  hWnd NULLw肵ꍇ́AfXNgbvLҁB

		  hView NULLw肷ƁAVɃvr[ʂ쐬ĕ\B\n
		  ߂l̒lLA hView Ɏw肷Ɠvr[ʂXVĕ\B

		  \param [in] hWnd vr[ʂ̏L
		  \param [in] hView vr[ʂ̃nh
		  \return vr[ʂ̃nh
		*/		
		HWND Show(HWND hWnd = NULL, HWND hView = NULL)
		{
			assert(h_ != NULL && show != NULL);
			HWND result = show(h_, hWnd, hView);
			h_ = NULL;
			return result;
		}

		/*!
		  \brief 𒆎~܂B

		  ̃\bhďóÃCX^X̑S\bhɂȂB
		*/
		void Cancel()
		{
			assert(h_ != NULL && cancel != NULL);
			cancel(h_);
			h_ = NULL;
		}

		/*!
		  \brief DLL[h܂B

		  \param [in] path DLL̃t@C
		  \exception DllException DLL̃[hɎs
		*/
		static void loadDll(LPCTSTR path);

		/*!
		  \brief DLL܂B
		*/
		static void releaseDll();
	};
}

#endif
