﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using text2prnDll;

namespace sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            preview = IntPtr.Zero;
        }

        IntPtr preview;

        private void button1_Click(object sender, EventArgs e)
        {

            // プレビュー用

            var prop = new T2PD_Property();

            prop.base_type = T2PD.BASE_FONT_SIZE;   // フォントサイズ指定
            prop.base_value = 20;                   // フォントサイズ 20pt
	        prop.column = 2;						// 2 段組
        	prop.column_space = 15;	    			// 段組の隙間 15mm
            prop.option = T2PD.OPTION_KINSOKU     | // 禁則処理と段組の区切り線とページ番号
                          T2PD.OPTION_COLUMN_LINE |
                          T2PD.OPTION_PAGE_NUMBER;
            prop.output_line_number = 1;            // 行番号出力
            prop.line_number_digit = 4;             // 行番号4桁
            prop.space_top = 10;					// ページ余白 10mm (左だけ20mm)
            prop.space_bottom = 10;
            prop.space_left = 20;
            prop.space_right = 10;
            prop.title = "【 サンプル 】";			// タイトル。

            try
            {
                var obj = new T2PD(prop, IntPtr.Zero);

                obj.OutputText(textBox1.Text);
                obj.NewColumn();
                obj.OutputText(textBox2.Text);

                preview = obj.Show(this, preview);
            }
            catch (PropertyException err)
            {
                MessageBox.Show("設定値エラー：" + err.ErrorCode);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // 印刷用

            var prop = new T2PD_Property();

            prop.base_type = T2PD.BASE_FONT_SIZE;   // フォントサイズ指定
            prop.base_value = 20;                   // フォントサイズ 20pt
            prop.column = 2;						// 2 段組
            prop.column_space = 15;	    			// 段組の隙間 15mm
            prop.option = T2PD.OPTION_KINSOKU | T2PD.OPTION_COLUMN_LINE;
                                                    // 禁則処理と段組の区切り線
            prop.output_line_number = 1;            // 行番号出力
            prop.line_number_digit = 4;             // 行番号4桁
            prop.space_top = 10;					// ページ余白 10mm (左だけ20mm)
            prop.space_bottom = 10;
            prop.space_left = 20;
            prop.space_right = 10;
            prop.title = "【 サンプル 】";			// タイトル。
            // ↑ この設定は通常はプレビュー用と同じものを使う。

            var dialog = new PrintDialog();
            if (dialog.ShowDialog() != DialogResult.OK)
                return;

            var g = dialog.PrinterSettings.CreateMeasurementGraphics();
            var dc = g.GetHdc();

            try
            {
                var obj = new T2PD(prop, dc);

                obj.OutputText(textBox1.Text);
                obj.NewColumn();
                obj.OutputText(textBox2.Text);

                T2PD_PrintInfo info = obj.GetPrintInfo();

/*
                info.pages を参照するなどして、
                必要ならば
                obj.SetOutputPage("1,3-7");
                のように印刷するページを決定する。
*/
                if (obj.Print() <= 0)
                {
                    MessageBox.Show("印刷失敗");
                }
            }
            catch (PropertyException err)
            {
                MessageBox.Show("設定値エラー：" + err.ErrorCode);
            }

            g.ReleaseHdc(dc);
        }
    }
}
