using System;
using System.Diagnostics;
using System.Runtime.InteropServices;


using System.Windows.Forms;

namespace text2prnDll
{
    /// <summary>
    /// ݒ
    /// </summary>
    [StructLayout(LayoutKind.Sequential, CharSet=CharSet.Unicode, Pack=1)]
    struct T2PD_Property
    {
        /// <summary>G[R[h</summary>
        public int error_code;
        /// <summary>tHgTCY̎w@</summary>
        public int base_type;
        /// <summary>tHgTCY</summary>
        public int base_value;
        /// <summary>ig</summary>
        public int column;
        /// <summary>^u</summary>
        public int tab_width;
        /// <summary>o̓IvV</summary>
        public int option;
        /// <summary>sԍ̕\Ԋu</summary>
        public int output_line_number;
        /// <summary>ŏ̍s̍sԍ</summary>
        public int initial_line_number;
        /// <summary>sԍ̌</summary>
        public int line_number_digit;
        /// <summary>tHg</summary>
        public String font_name;
        /// <summary>y[W]()</summary>
        public int space_top;
        /// <summary>y[W]()</summary>
        public int space_bottom;
        /// <summary>y[W]()</summary>
        public int space_left;
        /// <summary>y[W](E)</summary>
        public int space_right;
        /// <summary>s</summary>
        public int line_space;
        /// <summary>iǧ</summary>
        public int column_space;
        /// <summary>s֎~</summary>
        public String no_first_chars;
        /// <summary>s֎~</summary>
        public String no_last_chars;
        /// <summary>^Cg</summary>
        public String title;
        /// <summary>wb_</summary>
        public String header;
        /// <summary>tb^</summary>
        public String footer;
    }

    /// <summary>
    /// eɂĂ̏
    /// </summary>
    [StructLayout(LayoutKind.Sequential, CharSet=CharSet.Unicode, Pack=1)]
    struct T2PD_PrintInfo
    {
        /// <summary>tHgTCY</summary>
        public double font_size;
        /// <summary>1sɈ镶</summary>
        public int char_count_par_line;
        /// <summary>1igɈs</summary>
        public int line_count_par_column;
        /// <summary>y[W</summary>
        public int pages;
    }

    class T2PD
    {
        /// <summary>tHgTCY̎w@F1s̕Zo</summary>
        public const int BASE_CHAR_PAR_LINE	    = 1;
        /// <summary>tHgTCY̎w@F1i̍sZo</summary>
        public const int BASE_LINE_PAR_COLUMN	= 2;
        /// <summary>tHgTCY̎w@Fڎw</summary>
        public const int BASE_FONT_SIZE     	= 3;

        /// <summary>o̓IvVFE[ŉsȂ</summary>
        public const int OPTION_NO_WRAP	        = 0x0001;
        /// <summary>o̓IvVFigŋ؂</summary>
        public const int OPTION_COLUMN_LINE	    = 0x0002;
        /// <summary>o̓IvVFy[Wo͂</summary>
        public const int OPTION_PAGE_NUMBER	    = 0x0004;
        /// <summary>o̓IvVF֑s</summary>
        public const int OPTION_KINSOKU	        = 0x0008;
        /// <summary>o̓IvVFtHgLOGFONTŎw肷</summary>
        public const int OPTION_LOGFONT	        = 0x0010;

        /// <summary>G[Ȃ</summary>
        public const int ERROR_NONE             	= 0;
        /// <summary>G[Fbase_type s</summary>
        public const int ERROR_BASE_TYPE	        = -1;
        /// <summary>G[Fbase_value s</summary>
        public const int ERROR_BASE_VALUE	        = -2;
        /// <summary>G[Fcolumn s</summary>
        public const int ERROR_COLUMN	            = -3;
        /// <summary>G[Ftab_width s</summary>
        public const int ERROR_TAB_WIDTH	        = -4;
        /// <summary>G[Foutput_line_number s</summary>
        public const int ERROR_LINE_NUMBER	        = -5;
        /// <summary>G[Finitial_line_number s</summary>
        public const int ERROR_INIT_LINE_NUMBER	    = -6;
        /// <summary>G[Fline_number_digit s</summary>
        public const int ERROR_LINE_NUMBER_DIGIT	= -7;
        /// <summary>G[FtHgȂ</summary>
        public const int ERROR_FONT_NAME	        = -8;
        /// <summary>G[Fspace_top s</summary>
        public const int ERROR_SPACE_TOP	        = -9;
        /// <summary>G[Fspace_bottom s</summary>
        public const int ERROR_SPACE_BOTTOM     	= -10;
        /// <summary>G[Fspace_left s</summary>
        public const int ERROR_SPACE_LEFT       	= -11;
        /// <summary>G[Fspace_right s</summary>
        public const int ERROR_SPACE_RIGHT      	= -12;
        /// <summary>G[Fline_space s</summary>
        public const int ERROR_LINE_SPACE       	= -13;
        /// <summary>G[Fcolumn_space s</summary>
        public const int ERROR_COLUMN_SPACE     	= -14;
        /// <summary>G[Ftitle s</summary>
        public const int ERROR_TITLE                 = -15;

        /// <summary>G[Fy[W̗]傫߂</summary>
        public const int ERROR_PAGE_SPACE_LARGE	    = -50;
        /// <summary>G[Fig</summary>
        public const int ERROR_COLUMN_MANY      	= -51;
        /// <summary>G[F</summary>
        public const int ERROR_CHAR_MANY	        = -52;
        /// <summary>G[F1s\łȂ</summary>
        public const int ERROR_PRINT_NOTHING	    = -53;
        /// <summary>G[Fs</summary>
        public const int ERROR_LINE_MANY	        = -54;
        /// <summary>G[FtHg傫߂</summary>
        public const int ERROR_FONT_LARGE	        = -55;
        /// <summary>G[Fsԍ̌傫߂</summary>
        public const int ERROR_LINE_NO_DIGIT_LARGE	= -56;

        /// <summary>G[FtHg쐬s</summary>
        public const int ERROR_FONT_CREATE	        = -100;
        /// <summary>G[Fv^(DC)̐ݒُ</summary>
        public const int ERROR_PRINTER	            = -101;
        /// <summary>G[Fv^DCُ</summary>
        public const int ERROR_PRINTER_DC	        = -102;
        /// <summary>G[Fv^G[</summary>
        public const int ERROR_DEFAULT_PRINTER	    = -103;

        private IntPtr h_;

        /// <summary>
        /// ivr[ĵ߂̃CX^X쐬B
        /// </summary>
        /// <remarks>
        /// <para>
        /// dc  IntPtr.Zero w肵ꍇ́AK̃v^gp܂B
        /// </para>
        /// </remarks>
        /// <param name="prop">ݒ</param>
        /// <param name="dc">Ώۂ̃v^̃foCXReLXg</param>
        /// <exception cref="text2prnDll.PropertyException">ݒɊԈႢ</exception>
        public T2PD(T2PD_Property prop, IntPtr dc)
        {
            h_ = T2PD.Open(ref prop, dc);
            if (h_ == IntPtr.Zero)
            {
                throw new PropertyException(prop.error_code);
            }
        }

        /// <summary>
        /// 镶w肷B
        /// </summary>
        /// <remarks>
        /// <para>
        /// KvɉāAĂяo܂B
        /// </para>
        /// </remarks>
        /// <param name="text">镶</param>
        public void OutputText(String text)
        {
            Debug.Assert(h_ != IntPtr.Zero && text != null);
            T2PD.OutputText(h_, text);
        }

        /// <summary>
        /// iB
        /// </summary>
        public void NewColumn()
        {
            Debug.Assert(h_ != IntPtr.Zero);
            T2PD.NewColumn(h_);
        }

        /// <summary>
        /// y[WB
        /// </summary>
        public void NewPage()
        {
            Debug.Assert(h_ != IntPtr.Zero);
            T2PD.NewPage(h_);
        }

        /// <summary>
        /// eɊւ擾B 
        /// </summary>
        /// <returns>eɂĂ̏</returns>
        public T2PD_PrintInfo GetPrintInfo()
        {
            Debug.Assert(h_ != IntPtr.Zero);
            var info = new T2PD_PrintInfo();
            T2PD.GetPrintInfo(h_, ref info);
            return info;
        }

        /// <summary>
        /// y[Wԍw肷B
        /// </summary>
        /// <remarks>
        /// <para>
        /// Sy[Wꍇ́Ã\bhĂяoȂƁB
        /// </para>
        /// <para>
        /// ĂяóAŌ̌Ăяoê݂LƂȂB
        /// </para>
        /// <para>
        /// vr[́A̐ݒ͖B
        /// </para>
        /// </remarks>
        /// <param name="pages">y[Wԍ</param>
        /// <returns>
        /// <para>True = I</para>
        /// <para>False = y[Wԍ̎wɖ肠</para>
        /// </returns>
        public bool SetOutputPage(String pages)
        {
            Debug.Assert(h_ != IntPtr.Zero);
            return T2PD.SetOutputPage(h_, pages) != 0;
        }

        /// <summary>
        /// B
        /// </summary>
        /// <remarks>
        /// <para>
        /// ̃\bhďóÃCX^X̑S\bhɂȂB
        /// </para>
        /// </remarks>
        /// <returns>IR[hB1ȏȂ琳I</returns>
        public int Print()
        {
            Debug.Assert(h_ != IntPtr.Zero);
            int result = T2PD.Print(h_);
            h_ = IntPtr.Zero;
            return result;
        }

        /// <summary>
        /// vr[ʂ\B
        /// </summary>
        /// <remarks>
        /// <para>
        /// ̃\bhďóÃCX^X̑S\bhɂȂB
        /// </para>
        /// <para>
        /// wnd  null w肵ꍇ́AfXNgbvLҁB
        /// </para>
        /// <para>
        /// hView  IntPtr.Zero w肷ƁAVɃvr[ʂ쐬ĕ\B
        /// ߂l̒lLA hView Ɏw肷Ɠvr[ʂXVĕ\B
        /// </para>
        /// </remarks>
        /// <param name="wnd">vr[ʂ̏L</param>
        /// <param name="hView">vr[ʂ̃nh</param>
        /// <returns>vr[ʂ̃nh</returns>
        public IntPtr Show(Control wnd, IntPtr hView)
        {
            Debug.Assert(h_ != IntPtr.Zero);
            IntPtr hWnd = wnd == null ? IntPtr.Zero : wnd.Handle;

            hView = T2PD.Show(h_, hWnd, hView);
            h_ = IntPtr.Zero;

            return hView;
        }

        /// <summary>
        /// 𒆎~܂B
        /// </summary>
        /// <remarks>
        /// <para>
        /// ̃\bhďóÃCX^X̑S\bhɂȂB
        /// </para>
        /// </remarks>
        public void Cancel()
        {
            Debug.Assert(h_ != IntPtr.Zero);
            T2PD.Cancel(h_);
            h_ = IntPtr.Zero;
        }

        #region text2prn API ̐錾

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static IntPtr Open(ref T2PD_Property prop, IntPtr dc);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static void OutputText(IntPtr h, String text);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static void NewColumn(IntPtr h);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static void NewPage(IntPtr h);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static void GetPrintInfo(IntPtr h, ref T2PD_PrintInfo info);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static int SetOutputPage(IntPtr h, String pages);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static int Print(IntPtr h);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static IntPtr Show(IntPtr h, IntPtr hWnd, IntPtr hView);

        [DllImport("text2prn.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        extern public static void Cancel(IntPtr h);

        #endregion
    }

    /// <summary>
    /// text2prn DLL p̗O
    /// </summary>
    class PropertyException : Exception
    {
        private int code_;

        /// <summary>
        /// G[R[h
        /// </summary>
        public int ErrorCode
        {
            get { return code_; }

        }

        public PropertyException(int code)
        {
            code_ = code;
        }
    }
}
    